<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Usuarios</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas consultar la información de algún usuario?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-card>
        <v-toolbar dark color="grey">
          <v-toolbar-title class="white--text"
            >USUARIOS FRANQUICIA</v-toolbar-title
          >
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            label="Buscar usuarios..."
            flat
            dark
            solo-inverted
            append-icon="mdi-magnify"
            hide-details
          ></v-text-field>
          <v-progress-linear
            :active="loading"
            :indeterminate="loading"
            absolute
            bottom
            color="primary"
          />
        </v-toolbar>
        <v-row justify="space-between">
          <v-col class="pr-0 pb-0">
            <v-subheader style="position: relative;">
              <v-badge
                color="grey"
                dark
                inline
                :value="data.length"
                :content="data.length"
              >
                <span class="pt-2">DIRECTORIO</span>
              </v-badge>
              <v-tooltip bottom>
                <template v-slot:activator="{ on, attrs }">
                  <v-btn
                    fab
                    class="white--text"
                    color="primary"
                    v-bind="attrs"
                    v-on="on"
                    right
                    small
                    absolute
                    :to="{ name: 'accesos_usuarios_nuevo' }"
                  >
                    <v-icon>mdi-plus</v-icon>
                  </v-btn>
                </template>
                <span>Nuevo usuario</span>
              </v-tooltip>
            </v-subheader>
            <v-list
              subheader
              max-height="600"
              min-height="600"
              style="overflow: auto;"
            >
              <v-list-item-group color="primary" v-model="selected">
                <template v-for="(item, index) in data">
                  <v-divider :key="'divider-' + index" />
                  <v-list-item :key="'item-' + index" :value="item">
                    <v-list-item-avatar>
                      <v-icon x-large>mdi-account-circle-outline</v-icon>
                    </v-list-item-avatar>
                    <v-list-item-content>
                      <v-list-item-title class="text-decoration-underline">
                        {{ item.nombreUsuario }}
                      </v-list-item-title>
                      <v-list-item-subtitle>
                        {{ item.numeroEmpleado }}
                      </v-list-item-subtitle>
                    </v-list-item-content>
                  </v-list-item>
                </template>
                <v-divider />
              </v-list-item-group>
              <v-list-item v-if="loading">
                <div class="text-center">
                  <v-progress-circular
                    :size="100"
                    color="primary"
                    class="progress-circular"
                    indeterminate
                  ></v-progress-circular>
                </div>
              </v-list-item>
              <v-list-item>
                <v-list-item-content>
                  <v-list-item-title v-if="!search">
                    Realiza alguna busqueda...!
                  </v-list-item-title>
                  <v-list-item-title v-else-if="data && data.length == 0">
                    No se han encontrado resuldados...!
                  </v-list-item-title>
                </v-list-item-content>
              </v-list-item>
            </v-list>
          </v-col>
          <v-divider vertical></v-divider>
          <v-col class="d-flex text-center">
            <v-scroll-y-transition mode="out-in">
              <div
                v-if="!selected"
                class="title grey--text text--lighten-1 font-weight-light"
                style="align-self: center;"
              >
                Selecciona un usuario
              </div>
              <v-card
                v-else
                :key="selected.numeroEmpleado"
                class="mt-4 pt-6 mx-auto"
                flat
                max-width="400"
              >
                <v-avatar :color="selected.color" class="white--text" size="65">
                  {{ selected.initials }}
                </v-avatar>
                <v-card-title>
                  <router-link
                    class="text-decoration-underline"
                    :to="toEditUsuario(selected)"
                  >
                    {{ selected.nombreUsuario }}
                  </router-link>
                </v-card-title>
                <v-card-subtitle>
                  {{ selected.numeroEmpleado }}
                  <div class="mb-2">{{ selected.correo }}</div>
                </v-card-subtitle>
                <v-card-actions class="text-left">
                  <v-list
                    subheader
                    max-height="400"
                    min-height="400"
                    dense
                    style="overflow: auto;"
                  >
                    <v-subheader>OPCIONES</v-subheader>
                    <v-list-item dense>
                      <v-list-item-content>
                        <v-list-item-title>
                          <v-badge
                            color="primary"
                            inline
                            overlap
                            :value="selected.totalVistas"
                            :content="selected.totalVistas"
                          >
                            <v-icon color="grey lighten-1"
                              >mdi-file-document-multiple-outline</v-icon
                            >
                            <router-link
                              class="text-decoration-underline"
                              :to="toUsuarioVistas(selected)"
                            >
                              Vistas
                            </router-link>
                          </v-badge>
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                    <v-list-item dense>
                      <v-list-item-content>
                        <v-list-item-title>
                          <v-badge
                            color="primary"
                            inline
                            overlap
                            :value="selected.totalPerfilesFijos"
                            :content="selected.totalPerfilesFijos"
                          >
                            <v-icon color="grey lighten-1">
                              mdi-account-group-outline
                            </v-icon>
                            <router-link
                              class="text-decoration-underline"
                              :to="toUsuarioPerfilesFijos(selected)"
                            >
                              Perfiles Fijos
                            </router-link>
                          </v-badge>
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                    <v-list-item>
                      <v-list-item-content>
                        <v-list-item-title>
                          <v-badge
                            color="primary"
                            inline
                            overlap
                            :value="selected.totalPerfiles"
                            :content="selected.totalPerfiles"
                          >
                            <v-icon color="grey lighten-1">
                              mdi-account-group-outline
                            </v-icon>
                            <router-link
                              class="text-decoration-underline"
                              :to="toUsuarioPerfiles(selected)"
                            >
                              Perfiles
                            </router-link>
                          </v-badge>
                        </v-list-item-title>
                      </v-list-item-content>
                    </v-list-item>
                  </v-list>
                </v-card-actions>
              </v-card>
            </v-scroll-y-transition>
          </v-col>
        </v-row>
      </v-card>
    </div>
  </div>
</template>
<style scoped>
.nav-link {
  text-decoration: underline;
  color: inherit;
}
.progress-circular {
  position: initial;
}
</style>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
const colors = [
  "#2196F3",
  "#90CAF9",
  "#64B5F6",
  "#42A5F5",
  "#1E88E5",
  "#1976D2",
  "#1565C0",
  "#0D47A1",
  "#82B1FF",
  "#448AFF",
  "#2979FF",
  "#2962FF",
];

export default {
  name: "Component-AccesosUsuarios",
  data() {
    return {
      loading: false,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Accesos",
          disabled: false,
          exact: true,
          to: {
            name: "accesos",
          },
        },
        {
          text: "Usuarios",
          disabled: true,
        },
      ],
      selected: null,
      data: [],
      search: null,
      caseSensitive: false,
    };
  },
  watch: {
    search(val, prev) {
      this.getUsuarios();
    },
    selected(val) {
      if (val) {
        this.getVistasUsuario(val);
        this.getPerfilesUsuario(val);
        this.getPerfilesFijosUsuario(val);
      }
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    colorsLength() {
      return colors.length;
    },
    filter() {
      return this.caseSensitive
        ? (item, search, textKey) => item[textKey].indexOf(search) > -1
        : undefined;
    },
  },
  methods: {
    genRandomIndex(length) {
      return Math.ceil(Math.random() * (length - 1));
    },
    toEditUsuario(usuario) {
      return {
        name: "accesos_usuarios_edicion",
        params: {
          usuario: this.serviceCommons.objectToBase64(usuario),
        },
      };
    },
    toUsuarioVistas(usuario) {
      return {
        name: "accesos_usuarios_edicion",
        params: {
          usuario: this.serviceCommons.objectToBase64(usuario),
        },
        query: {
          vistas: this.serviceCommons.objectToBase64({}),
        },
      };
    },
    toUsuarioPerfilesFijos(usuario) {
      return {
        name: "accesos_usuarios_edicion",
        params: {
          usuario: this.serviceCommons.objectToBase64(usuario),
        },
        query: {
          perfiles_fijos: this.serviceCommons.objectToBase64({}),
        },
      };
    },
    toUsuarioPerfiles(usuario) {
      return {
        name: "accesos_usuarios_edicion",
        params: {
          usuario: this.serviceCommons.objectToBase64(usuario),
        },
        query: {
          perfiles: this.serviceCommons.objectToBase64({}),
        },
      };
    },
    getVistasUsuario(usuario) {
      axios("/accesos/sistema/vistas/v1/usuarios/" + usuario.numeroEmpleado)
        .then((response) => {
          let data = response.data;
          if (data) {
            usuario.totalVistas = data.resultado.vistas.length;
          }
        })
        .catch((error) => {});
    },
    getPerfilesUsuario(usuario) {
      axios("/accesos/sistema/perfiles/v1/usuarios/" + usuario.numeroEmpleado)
        .then((response) => {
          let data = response.data;
          if (data) {
            usuario.totalPerfiles = data.resultado.perfiles.length;
          }
        })
        .catch((error) => {});
    },
    getPerfilesFijosUsuario(usuario) {
      axios(
        "/accesos/sistema/perfiles/v1/usuarios/" +
          usuario.numeroEmpleado +
          "/fijos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            usuario.totalPerfilesFijos = data.resultado.perfiles.length;
          }
        })
        .catch((error) => {});
    },
    getUsuarios() {
      this.loading = true;
      let body = {
        usuario: this.search,
      };
      axios
        .post("/accesos/sistema/usuarios/v1/busqueda", body)
        .then((response) => {
          let data = response.data;
          if (data) {
            this.setUsuarios(data.resultado.usuarios);
          }
        })
        .catch((error) => {
          if (error.response) {
            this.data = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
    setUsuarios(data) {
      if (data) {
        this.data = data.map((itemUsuario, indexItemUsuario) => {
          let nombreUsuario = this.serviceCommons.titleCase(
            itemUsuario.nombreUsuario
          );
          itemUsuario.nombreUsuario = nombreUsuario;
          itemUsuario.usuario =
            itemUsuario.numeroEmpleado + " - " + nombreUsuario;
          itemUsuario.initials = this.serviceCommons.initialLetters(
            nombreUsuario
          );
          itemUsuario.no = indexItemUsuario + 1;
          itemUsuario.color = colors[this.genRandomIndex(this.colorsLength)];
          itemUsuario.totalVistas = null;
          itemUsuario.totalPerfiles = null;
          itemUsuario.totalPerfilesFijos = null;
          return itemUsuario;
        });
      }
    },
  },
};
</script>
